c$Id:$
      subroutine elmt05(d,ul,xl,ix,tl,s,p,ndf,ndm,nst,isw)

c      * * F E A P * * A Finite Element Analysis Program

c....  Copyright (c) 1984-2011: Regents of the University of California
c                               All rights reserved

c-----[--.----+----.----+----.-----------------------------------------]
c     Modification log                                Date (dd/mm/year)
c       Original version                                    01/11/2006
c-----[--.----+----.----+----.-----------------------------------------]
c     Purpose: 4-Node Plane Quad Bloch

c     Inputs:

c     Outputs:
c-----[--.----+----.----+----.-----------------------------------------]
      implicit none

      include  'bdata.h'
      include  'cdata.h'
      include  'eldata.h'
      include  'eltran.h'
      include  'hdata.h'
      include  'tdata.h'
      include  'pointer.h'
      include  'comblk.h'
      include  'ubloch.h'
            
      integer ix(nen),ndf,ndm , nst , isw, tdof
      real*8  d(*), ul(*), xl(ndm,nen), tl(*), p(*), s(nst,nst)
      !========
      integer ii,jj,kk,eb(nen+2),xi,xr
      real*8 kl(8,8),kd(16,16),facc,facs,xlb(ndm,nen),dx,dy,fa
      real*8 cr, cs, pi1(2), pi2(2), pi3(2), pi4(2), pint(2,4), pii(2)
      real*8 rl, sl, DJ, H(2,8), Hd(2,4), IJa(2,2), B(3,8), C(3,3),E,nu
      real*8 BtC(8,3), BtCB(8,8), F_loc(8,8), k_loc(8,8), M_loc(8,8)

      save
      
!======================================================================= 
!-----------
      if( isw.eq.1 ) then
      
       call inmate(d, tdof, 0, 1)
       
!=======================================================================  
      
      elseif( isw.eq.3 .or. isw.eq.5) then
       
       xlb = xl
       
       if (ma .ge. 10) then  !SI SE CAMBIA ALGO DE ESTE CONDICIONAL, HAY QUE HACERLO EN EL DE ABAJO
        !write(*,*) 'material',n,ma
        do ii = 1,bel
         eb = mr(up(1)+ (ii-1)*(nen+2) : up(1)+(nen+2)*ii-1) !elto i de bloch
         !write(*,*) ii
         if ( n .eq. eb(1) ) then  
c          write(*,*) n
c          write(*,*) 'elto bloch',eb(3:nen+2)
c          write(*,*) 'elto tipic',ix      
          do jj = 1,nen
           xi = eb(3+jj-1)
           xlb(1,jj) = hr(np(43) + 2*(xi-1)  )
           xlb(2,jj) = hr(np(43) + 2*(xi-1)+1)
          end do
          exit
         end if
        end do
       end if
       
       
       
       k_loc = 0.0d0
       M_loc = 0.0d0
       
       E = d(1)
       nu = d(2)
       
       if (d(16).eq.2) then !PLANE STRAIN
        fa = E*(1.0d0-nu)/((1.0d0+nu)*(1.0d0-2.0d0*nu))
        C(1,:) = fa*(/ 1.0d0, nu/(1.0d0-nu), 0.0d0 /)
        C(2,:) = fa*(/ nu/(1.0d0-nu), 1.0d0, 0.0d0 /)
        C(3,:) = fa*(/0.0d0, 0.0d0,(1.0d0-2.0d0*nu)/(2.0d0*(1.0d0-nu))/)
       
       elseif (d(16).eq.1) then !PLANE STRESS
        fa = d(14)
        C(1,:)=fa*(E/(1.0d0-nu**2))*(/ 1.0d0, nu, 0.0d0 /)
        C(2,:)=fa*(E/(1.0d0-nu**2))*(/ nu, 1.0d0, 0.0d0 /)
        C(3,:)=fa*(E/(1.0d0-nu**2))*(/ 0.0d0, 0.0d0, (1.0d0-nu)/2.0d0 /)
        !write(*,*) d(14)
       end if       

       cr = 1.0d0 / dsqrt(3.0d0)
       cs = 1.0d0 / dsqrt(3.0d0)
       
       pi1 = (/  cr,  cs /)
       pi2 = (/ -cr,  cs /)
       pi3 = (/ -cr, -cs /)
       pi4 = (/  cr, -cs /)
       
       pint(1,:) = (/ pi1(1), pi2(1), pi3(1), pi4(1) /)
       pint(2,:) = (/ pi1(2), pi2(2), pi3(2), pi4(2) /)
       
       do ii=1,4
        
        pii = pint(:,ii)
        
        rl = pii(1)
        sl = pii(2)
        
        call evalH4_2(H,Hd,rl,sl)
        call jacobiano4_2(IJa,DJ,Hd,xlb)
        call evalB4_2(B,IJa,Hd)
        
        BtC = matmul(transpose(B),C)
        BtCB = matmul(BtC,B)
        
        F_loc = DJ*BtCB
        
        !local stiffness
        do jj=1,8
         do kk=1,8
          k_loc(jj,kk) = k_loc(jj,kk) + F_loc(jj,kk)
         end do
        end do
        
        F_loc = matmul(transpose(H),H)
    
        F_loc = d(4)*F_loc*DJ
        
        !local mass
        do jj=1,8
         do kk=1,8
          M_loc(jj,kk) = M_loc(jj,kk) + F_loc(jj,kk)
         end do
        end do
        
       end do
       
       !-------------------------------------
       
       if ( isw.eq.3 ) then
        kl = k_loc
       else 
        kl = M_loc
       end if
       
       !DOF duplicados
       kd = 0.0d0
       do ii = 1,8
        do jj = 1,8
          kd(2*ii-1,2*jj-1) = kl(ii,jj)
          kd(2*ii  ,2*jj  ) = kl(ii,jj)
        end do
       end do
       
       !write(*,*) nummat,n,ma
       if (ma .ge. 10) then
        !do ii = 1,bel
         !eb = mr(up(1)+ (ii-1)*(nen+2) : up(1)+(nen+2)*ii-1) !elto i de bloch
         !if ( n .eq. eb(1) ) then
          do jj = 1,nen
           if (eb(jj+2).ne.ix(jj)) then
            !write(*,*) 'n',n
            !write(*,*) 'blo',eb(3:nen+2)
            !write(*,*) 'con',ix
            !write(*,*) 'fil',jj
            xi = eb(3+jj-1)
            xr = ix(jj)
            dx = hr(np(43) + 2*(xi-1)  ) - hr(np(43) + 2*(xr-1)  ) !xi-xr
            dy = hr(np(43) + 2*(xi-1)+1) - hr(np(43) + 2*(xr-1)+1) !yi-yr
            !write(*,*) dx,dy 

            facc = cos(ckx*dx + cky*dy)
            facs = sin(ckx*dx + cky*dy)

            call app_bloch4_2(kd,jj,facc,facs)
           
           end if
          end do
         !end if
        !end do
       end if
c       write(*,*) 'local',n,isw
c       write(*,*) 'conec',ix
c       do ii = 1,16
c        write(*,'(16E10.3)') kd(ii,:)
c       end do
       
       s = kd
       
      end if
    
      end subroutine
       
       
!=======================================================================

      subroutine app_bloch4_2(A,fi,facc,facs)
      
      implicit none
      
      integer fi
      real*8 A(16,16),ur(16),ui(16),vr(16),vi(16),facc,facs
      
      
      !rows
      ur = A(4*fi-3,:)
      ui = A(4*fi-2,:)
      vr = A(4*fi-1,:)
      vi = A(4*fi  ,:)
      A(4*fi-3,:) = ur*facc - ui*facs     !RefR = RefR + ImaR(C) - ImaI(S)
      A(4*fi-2,:) = ui*facc + ur*facs     !RefI = RefI + ImaI(C) + ImaR(S)
      A(4*fi-1,:) = vr*facc - vi*facs     
      A(4*fi  ,:) = vi*facc + vr*facs     
           
      !cols
      ur = A(:,4*fi-3)
      ui = A(:,4*fi-2)
      vr = A(:,4*fi-1)
      vi = A(:,4*fi  )
      A(:,4*fi-3) = ur*facc - ui*facs     !RefR = RefR + ImaR(C) - ImaI(S)
      A(:,4*fi-2) = ui*facc + ur*facs     !RefI = RefI + ImaI(C) + ImaR(S)
      A(:,4*fi-1) = vr*facc - vi*facs     
      A(:,4*fi  ) = vi*facc + vr*facs 
      
      end subroutine
 
!=======================================================================
!=======================================================================
!=======================================================================
     
      subroutine evalH4_2(H,Hd,rl,sl)
      
      implicit none
      
      real*8 rl, sl, H(2,8), Hd(2,4)
      
      H = 0.0D0
      
      !shape functions
      H(1,1) = 0.25d0*(1+rl)*(1+sl)
      H(1,3) = 0.25d0*(1-rl)*(1+sl)
      H(1,5) = 0.25d0*(1-rl)*(1-sl)
      H(1,7) = 0.25d0*(1+rl)*(1-sl)
      
      H(2,2) = 0.25d0*(1+rl)*(1+sl)
      H(2,4) = 0.25d0*(1-rl)*(1+sl)
      H(2,6) = 0.25d0*(1-rl)*(1-sl)
      H(2,8) = 0.25d0*(1+rl)*(1-sl)
      
      !derivatives
      !d/dr
      Hd(1,1) =  0.25d0*(1+sl)
      Hd(1,2) = -0.25d0*(1+sl)
      Hd(1,3) = -0.25d0*(1-sl)
      Hd(1,4) =  0.25d0*(1-sl)
      
      !d/ds
      Hd(2,1) =  0.25d0*(1+rl)
      Hd(2,2) =  0.25d0*(1-rl)
      Hd(2,3) = -0.25d0*(1-rl)
      Hd(2,4) = -0.25d0*(1+rl)
      
      end subroutine

!=======================================================================   
      subroutine jacobiano4_2(IJa,DJ,Hd,xl)
      
      implicit none
      
      real*8 Ja(2,2), DJ, IJa(2,2), Hd(2,4), xlt(4,2), xl(2,4), dG
      
      xlt = transpose(xl)
      Ja = matmul(Hd,xlt)
      
      DJ = (Ja(1,1)*Ja(2,2)) - (Ja(1,2)*Ja(2,1))
      
      dG = 1.0d0 / DJ
      
      IJa(1,:) = dG*(/  Ja(2,2),-Ja(1,2) /)
      IJa(2,:) = dG*(/ -Ja(2,1), Ja(1,1) /)
      
      end subroutine
!=======================================================================         
      subroutine evalB4_2(B,IJa,Hd)
      
      implicit none
      
      integer*8 i
      real*8 B(3,8), IJa(2,2), Hd(2,4), dN(2,4)
      
      dN = matmul(IJa,Hd)

      B(1,:) = (/ dN(1,1), 0.0d0, dN(1,2), 0.0d0, dN(1,3), 0.0d0, 
     1            dN(1,4), 0.0d0 /)
      B(2,:) = (/ 0.0d0, dN(2,1), 0.0d0, dN(2,2), 0.0d0, dN(2,3),
     1            0.0d0, dN(2,4) /)
      B(3,:) = (/ dN(2,1),dN(1,1),dN(2,2),dN(1,2),dN(2,3),dN(1,3),
     1            dN(2,4),dN(1,4) /)
    
      
      end subroutine


 

      
      
